'*********************************************************** 
function ShowDialog(title,text)
    print "ShowDialog - ";title
    m.dialog = createObject("roSGNode","Dialog")
    m.dialog.title = title
    m.dialog.optionsDialog = true
    m.dialog.message = text
    m.dialog.buttons = ["OK"]
    m.dialog.observeField("buttonSelected","HideDialog")
    
    m.global.mainScene.dialog = m.dialog
    
    UpdateAllFonts(m.dialog)
end function

function HideDialog()
    if m.dialog <> invalid
        m.dialog.close = true
    end if
end function
'*********************************************************** 
function ShowLoadingDialog(title)
    m.progressdialog = createObject("roSGNode", "ProgressDialog")
    m.progressdialog.title = title
    
    m.global.mainScene.dialog = m.progressdialog
    
    UpdateAllFonts(m.progressdialog)
end function
 
function HideLoadingDialog()
    if m.progressdialog <> invalid
        m.progressdialog.close = true
    end if
end function
'***********************************************************
function ShowPinDialog(title, onHide)
    print "ShowPinDialog - ";title
    m.pindialog = createObject("roSGNode","PinDialog")
    m.pindialog.title = title +" - "+getTr("Enter PIN")+":"
    m.pindialog.optionsDialog = true
    m.pindialog.pin = ""
    m.pindialog.buttons = [getTr("OK"), getTr("Cancel")]
    m.pindialog.observeField("buttonSelected", onHide)
    
    m.global.mainScene.dialog = m.pindialog
    
    UpdateAllFonts(m.pindialog)
    m.pindialog.buttonGroup.textFont = m.global.fonts.regular20
    m.pindialog.buttonGroup.focusedTextFont = m.global.fonts.regular20
end function

function GetEnteredPin() as String
    if m.pindialog <> invalid
        if m.pindialog.buttonSelected = 0
            return m.pindialog.pin
        end if
    end if
    return ""
end function

function HidePinDialog()
    print "HidePinDialog..."
    if m.pindialog <> invalid
        if m.pindialog.buttonSelected = 0
            m.pindialog.pin = ""
        end if
        m.pindialog.close = true
    end if
end function
'*********************************************************** 
Function UpdateAllFonts(node)
    for i=0 to node.getChildCount()-1
        if node.getChild(i).hasField("font")
            node.getChild(i).font = m.global.fonts.regular20
        end if
        
        for j=0 to node.getChild(i).getChildCount()-1
            if node.getChild(i).getChild(j).hasField("font")
                node.getChild(i).getChild(j).font = m.global.fonts.regular20
            end if
        end for
    end for
end function
'***********************************************************
'*********************************************************** 
Function textEllipsis(text, numbers) As String
    newtext = ""
    for i=1 to Len(text)
        ch = Mid(text,i,1)
        if(ch <> "\")
            newtext = newtext+ch
        end if
    end for
    if Len(newtext) > numbers
        return Left(newtext, numbers) + "..."
    end if
    return newtext
End Function
'******************************************************
Function findSymbol(text, symbol) As Boolean
    for i=1 to Len(text)
        ch = Mid(text,i,1)
        if(ch = symbol)
            return true
        end if
    end for
    return false
End Function
'******************************************************
Function findInString(text, strng) As Boolean
    for i=1 to Len(text)
        ch = Mid(text,i,strng.Len())
        if(ch = strng)
            return true
        end if
    end for
    return false
End Function
'******************************************************
Function CheckStreamUrl(url) As Boolean
    if url<>invalid
        if findInString(url,"http") or findInString(url,"http")
            return true
        end if
    end if
    print "INCORRECT URL = "+url
    return false
End Function
'******************************************************
Function GetStreamFormatByUrl(url) As String
    format = "hls"
    if (findInString(url,"ts"))
        format = "ts"
    end if
    
    print "STREAM FORMAT = "+format
    
    return format
End Function
'******************************************************
function CheckIsCinema(description) as Boolean
    if description <> invalid and description.Len() >= 4
        if description.Mid(0,4) = "kino"
            return true
        end if
    end if
    return false
end function
'******************************************************
function GetCinemaTitle(description) as String
    title = ""
    if description <> invalid and description.Len() >= 4
        if description.Mid(0,4) = "kino"
            title = description.Mid(5)
        end if
    end if
    return title
end function
'******************************************************
'******************************************************
'******************************************************
function GetTimeShiftSeconds(channelNum) as Integer
    if m.global.channels <> invalid and m.global.channels.Count() > channelNum
        if m.global.user.timeShift and m.global.channels[channelNum].record
            return -(getTimeZoneOffsetById(m.global.channels[channelNum].timezoneId, m.global.timeZones) - getTimeZoneOffsetById(m.global.user.timeZoneId, m.global.timeZones))
        end if
    else
        print "GetTimeShiftSeconds: wrong chanel num"   
    end if
    return 0
end function
'******************************************************
function findProgramNodeByTimestamp(timestamp, programs) as Integer
    if timestamp<>invalid and programs<>invalid
        for i = 0 to programs.getChildCount()-1
            if(timestamp >= programs.getChild(i).programTimestamp and timestamp < programs.getChild(i).programEndTimestamp) 
                return i
            end if
        end for
        print "ERROR! findProgramNodeByTimestamp - outside program list"
        if programs.getChildCount() > 0 and timestamp < programs.getChild(0).programTimestamp
            return -2
        end if
        return -1
    end if
    print "ERROR! findProgramNodeByTimestamp - invalid input"
    return -1
end function
'******************************************************
function findProgramByTimestamp(timestamp, programs) as Integer
    for i = 0 to programs.Count()-1
        if(timestamp >= programs[i].timestamp and timestamp < programs[i].endTimestamp) 
            return i
        end if
    end for
    print "ERROR! findProgramByTimestamp - outside program list"
    if programs.Count() > 0 and timestamp < programs[0].timestamp
        return -2
    end if
    return -1
end function
'******************************************************
Function convertTimestampToHHMM(_timestamp) As String 
    date = CreateObject("roDateTime")
    date.FromSeconds(_timestamp)
    return convertDateToTime(date)
End Function
'******************************************************
Function convertDateToTime(_date) As String 
    return convertNumberTime(_date.GetHours())+":"+convertNumberTime(_date.GetMinutes())
End Function
'******************************************************
Function convertSecondsToHHMM(seconds) As String
    time = ""
    hours% = seconds/3600
    minutes% = seconds/60 - hours%*60
    
    return hours%.tostr()+":"+convertNumberTime(minutes%)
End Function
'******************************************************
Function convertSecondsToTime(seconds) As String
    if seconds < 0
        seconds = -seconds
    end if
    
    time = ""
    hours% = seconds/3600
    minutes% = seconds/60 - hours%*60
    seconds% = seconds - minutes%*60 - hours%*3600
    if hours% > 0
        return hours%.tostr()+":"+convertNumberTime(minutes%)+":"+convertNumberTime(seconds%)
    end if
    return convertNumberTime(minutes%)+":"+convertNumberTime(seconds%)
End Function
'******************************************************
Function convertNumberTime(number) As String
    time = ""
    if(number<10)
        time = "0"+number.tostr()
    else
        time = number.tostr()
    end if
    return time
End Function
'******************************************************
Function convertDateToDDMMYYYY(_date) As String 
    return convertNumberTime(_date.GetDayOfMonth())+"."+convertNumberTime(_date.GetMonth())+"."+(_date.GetYear()).tostr()
End Function
'******************************************************
function getDayName(day) As String
    if (day = 0)
        return getTrDay("Sunday")
    else if(day = 1)
        return getTrDay("Monday")
    else if(day = 2)
        return getTrDay("Tuesday")
    else if(day = 3)
        return getTrDay("Wednesday")
    else if(day = 4)
        return getTrDay("Thursday")
    else if(day = 5)
        return getTrDay("Friday")
    else if(day = 6)
        return getTrDay("Saturday")
    end if
    return getTrDay("Today")
end function
'*********************************************************** 
'------------------- TIMEZONE ------------------------------
'*********************************************************** 

'*********************************************************** 
function getTimeZoneById(id, timeZones) as Integer
    if timeZones <> invalid
        for i = 0 to timeZones.Count()
            if(timeZones[i].id = id) 
                return timeZones[i].time.toint()
            end if
        end for
    end if
    return 0
End function
'*********************************************************** 
function getTimeZoneNameById(id, timeZones) as String
    if timeZones <> invalid
        for i = 0 to timeZones.Count()
            if(timeZones[i].id = id) 
                return "("+timeZones[i].name+")"
            end if
        end for
    end if
    return ""
End function
'*********************************************************** 
Function getTimeZoneOffsetById(id, timeZones) as Integer
    if timeZones <> invalid
        for i = 0 to timeZones.Count()
            if(timeZones[i].id = id)
                return timeZones[i].dateOffset.toint()
            end if
        end for
    end if
    return 0
End Function
'*********************************************************** 
'------------------- LANGUAGE ------------------------------
'***********************************************************
Function getLanguageName(lngId) As String
        if(lngId = 1) return "ua"
        if(lngId = 2) return "en"
        if(lngId = 3) return "ru"
        return "en"
End Function
'******************************************************
Function getLanguageId(lngId) As Integer
        if(lngId = "ua") return 1
        if(lngId = "en") return 2
        if(lngId = "ru") return 3
        return 2
End Function
'*********************************************************** 
'------------------- CURRENCY ------------------------------
'***********************************************************
Function getCurrencyName(currencyId) As String
        if(currencyId = 1) return "EUR"
        if(currencyId = 2) return "USD"
        return "USD"
End Function
