sub init()
    print "INIT: MainScene"
    m.top.id = "MainScene"
    m.top.backgroundURI = "pkg:/images/background.jpg"
    
    m.top.overhang = m.top.createChild("Overhang")
    m.top.overhang.logoUri = "pkg:/images/logo.png"
    
    m.top.overhang.optionsColor = "0xffffffff"  
    m.top.overhang.optionsDimColor = "0xffffffff"
    m.top.overhang.optionsIconColor = "0xffffffff"
    m.top.overhang.optionsIconDimColor = "0xffffffff"
    m.top.overhang.showOptions = true
    m.top.overhang.optionsAvailable = true
    
    m.global.addFields({
        mainScene: m.top,
        archiveDateString: "",
        menuID: 0,
        loading: false,
    })
    
    setFonts()

    for i=0 to m.top.overhang.getChildCount()-1
        if m.top.overhang.getChild(i).hasField("font")
            m.top.overhang.getChild(i).font = m.global.fonts.regular20
        end if
    end for
    
    m.AuthorizeScreen = m.top.createChild("AuthorizeScreen")
    m.AuthorizeScreen.visible = true
    m.AuthorizeScreen.observeField("visible", "OnAuthorizeScreenVisibleChange")
end sub

sub OnAuthorizeScreenVisibleChange()
    print "OnAuthorizeScreenVisibleChange = ";m.AuthorizeScreen.visible
    if m.AuthorizeScreen.visible = false
        CreatePanelSet()
        
        checkInfoMessage()
    end if
end sub

sub LogOut()
    if m.top.logout
        m.top.removeChild(m.top.panelSet)
        m.top.panelSet = invalid
        m.MainMenu = invalid
        m.GenreListPanel = invalid
        m.curentGenre = invalid
        m.SettingsPanel = invalid
        
        m.global.menuID = 0
        m.global.language = "en"
        
        m.AuthorizeScreen.visible = true
        m.AuthorizeScreen.logout = true
        m.top.logout = false
    endif
end sub
'*********************************************************** 
sub CreatePanelSet()
    CreateVideoPlayer()
    if m.top.panelSet = invalid
        m.top.panelSet = m.top.createChild("PanelSet")
    endif
    
    CreateMainMenu()
    CreateGenreList()
    'CreateChannelGrid()
    
    m.MainMenu.setFocus(true)
end sub
'***********************************************************
'----------- MAIN MENU --------------------------------------
'*********************************************************** 
sub CreateMainMenu()
    if(m.MainMenu = invalid)
        print "...CREATE: Main Menu" 
        m.MainMenu = m.top.panelSet.createChild("MainMenu")
        m.MainMenu.list.observeField("itemFocused", "OnMenuChange")
        m.MainMenu.list.observeField("itemSelected", "OnMenuSelected")
    end if
end sub

sub OnMenuChange()
    print "OnMenuChange..."
    m.top.overhang.title = ""
    m.top.overhang.optionsText = ""
    
    if not m.top.panelSet.isGoingBack
        if m.currentMenu <> invalid
            print "OnMenuChange: from - ";m.currentMenu.title
        end if
        
        m.currentMenu = m.MainMenu.list.content.getChild(m.MainMenu.list.itemFocused)
        m.global.menuID = m.currentMenu.id
        m.GenreListPanel.menuID = m.currentMenu.id
        print "OnMenuChange: to - ";m.currentMenu.title
        
    else
        print "OnMenuChange: isGoingBack Panels=";m.top.panelSet.numPanels
        if m.global.menuID = 0
            RemoveChannelGrid()
            RemoveProgramsList()
        else if m.global.menuID = 1
            RemoveMovieSearch()
            RemoveMoviesGenres()
            RemoveMoviesGrid()
            RemoveMovieInfo()
        else if m.global.menuID = 2
            RemoveSetting()
        end if
    end if

end sub

sub OnMenuSelected()
    print "OnMenuSelected..."
end sub
'*********************************************************** 
sub CreateGenreList()
    if(m.GenreListPanel=invalid)
        print "...CREATE: Genre ListPanel" 
        m.GenreListPanel = createObject("RoSGNode","GenreListPanel")
        m.GenreListPanel.list.observeField("itemFocused", "OnGenreChange")
        m.GenreListPanel.list.observeField("itemSelected", "OnGenreSelected")
        m.GenreListPanel.createNextPanelOnItemFocus = true
        m.GenreListPanel.list.observeField("createNextPanelIndex", "OnCreateNextPanel")
        m.top.panelSet.appendChild(m.GenreListPanel)
        m.top.GenreListPanel = m.GenreListPanel
    end if
end sub

sub OnGenreChange()
    print "OnGenreChange..."
    if m.global.menuID = 0
        m.top.overhang.title = getTr("Television")
    else if m.global.menuID = 1
        m.top.overhang.title = getTr("Cinema")
    else if m.global.menuID = 2
        m.top.overhang.title = getTr("Settings")
    end if
    m.top.overhang.optionsText = ""

    if not m.top.panelSet.isGoingBack
        if m.curentGenre <> invalid
            print "OnGenreChange: from - ";m.curentGenre.title
        end if

        if m.GenreListPanel.list.content<>invalid
            m.curentGenre = m.GenreListPanel.list.content.getChild(m.GenreListPanel.list.itemFocused)
            print "OnGenreChange: to - ";m.curentGenre.title
        end if
        
        if m.global.menuID = 0
        
            CreateChannelGrid()
            m.GenreListPanel.nextPanel = m.ChannelsGridPanel
            m.ChannelsGridPanel.genreName = m.curentGenre.title
            m.ChannelsGridPanel.genreId = m.curentGenre.id
            m.ChannelsGridPanel.leftLabel.text = ""
            
        else if m.global.menuID = 1

            if m.GenreListPanel.list.itemFocused = 0
                CreateMovieSearch()
                m.GenreListPanel.nextPanel = m.MovieSearchPanel
                RemoveMoviesGrid()
                m.global.loading = false
            else
                CreateMoviesGenres()
                m.MoviesGenresPanel.categoryIndex = m.GenreListPanel.list.itemFocused
                m.GenreListPanel.nextPanel = m.MoviesGenresPanel

                'CreateMoviesGrid()
                'm.MoviesGridPanel.parentPanel = "genres"
                'm.GenreListPanel.nextPanel = m.MoviesGridPanel
                'm.MoviesGridPanel.genreName = m.curentGenre.title
                'm.MoviesGridPanel.genreId = m.curentGenre.id
                'm.MoviesGridPanel.leftLabel.text = ""
            end if

        else if m.global.menuID = 2

            CreateSetting()
            m.GenreListPanel.nextPanel = m.SettingsPanel
            m.SettingsPanel.settingsID = m.GenreListPanel.list.itemFocused
            
        end if
    else
        print "OnGenreChange: isGoingBack Panels=";m.top.panelSet.numPanels
        if m.global.menuID = 0
            RemoveProgramsList()
        else if m.global.menuID = 1
            RemoveMoviesGrid()
            RemoveMovieInfo()
        end if
    end if

end sub

sub OnCreateNextPanel()
    print "OnCreateNextPanel..."

end sub

sub OnGenreSelected()
    print "OnGenreSelected..."
    if m.global.menuID = 1
        if m.GenreListPanel.list.itemFocused = 0
            RemoveMoviesGenres()
        end if
    end if
end sub

function GetGenreNum(id) as Integer
    genre_num = 0
    for each genre in m.global.genres
        if genre.id.tostr() = id.tostr()
            return genre_num
        end if
        genre_num++
    end for
    return 0
end function
'*********************************************************** 
'----------- CHANNELS --------------------------------------
'*********************************************************** 
sub CreateChannelGrid()
    if(m.ChannelsGridPanel=invalid)
        print "...CREATE: Channels GridPanel" 
        m.ChannelsGridPanel = createObject("RoSGNode","ChannelsGridPanel")
        m.ChannelsGridPanel.grid.observeField("itemFocused", "OnChannelChange")
        m.ChannelsGridPanel.grid.observeField("itemSelected", "OnChannelSelected")
        'm.top.panelSet.appendChild(m.ChannelsGridPanel)
    end if
end sub

sub RemoveChannelGrid()
    if m.ChannelsGridPanel <> invalid
        print "...REMOVE: Channels GridPanel"
        m.ChannelsGridPanel = invalid
    end if
end sub

sub OnChannelChange()
    print "OnChannelChange..."
    m.top.overhang.title = m.curentGenre.title
    m.top.overhang.optionsText = getTr("To Favorite")
    if m.top.panelSet.isGoingBack
        print "OnChannelChange: isGoingBack Panels=";m.top.panelSet.numPanels
    else
        SetChannel(m.ChannelsGridPanel.grid.itemFocused)
    end if
end sub

sub OnTVchannelChanged()
    print "OnTVchannelChanged..."
    if m.top.VideoPlayer<>invalid and m.top.VideoPlayer.onTop        
        SetChannel(m.top.TVchannel)
        
        m.top.TVchannel = m.curentChannel.channelNum
        print "OnTVchannelChanged: ";m.top.TVchannel
        GetUrl(true)
    end if
end sub

sub SetChannel(index)
    if index >= m.ChannelsGridPanel.grid.content.getChildCount()
        index = 0
    end if
    if index < 0
        index = m.ChannelsGridPanel.grid.content.getChildCount()-1
    end if
    if m.ChannelsGridPanel.grid.itemFocused <> index
        m.ChannelsGridPanel.grid.jumpToItem = index
    end if

    m.curentChannel = m.ChannelsGridPanel.grid.content.getChild(index)
    print "OnChannelChange: ";(m.top.TVchannel+1);".";(m.curentChannel.channelName)
    
    'm.ChannelsGridPanel.leftLabel.text = m.ChannelsGridPanel.genreName
    m.ChannelsGridPanel.rightLabel.text = (m.ChannelsGridPanel.grid.itemFocused+1).tostr()+" "+getTr("of")+" "+m.ChannelsGridPanel.grid.content.getChildCount().tostr()
    
    CreateProgramsList()
    if m.top.VideoPlayer.playingChannel <> invalid and m.top.VideoPlayer.playingChannel.channelID = m.curentChannel.channelID
        m.ProgramsListPanel.dayNum = m.top.VideoPlayer.playingDayNum
    else
        m.ProgramsListPanel.dayNum = 0
    end if
    m.ProgramsListPanel.channelName = m.curentChannel.channelName
    m.ProgramsListPanel.channelNum = m.curentChannel.channelNum
    m.ProgramsListPanel.channelId = m.curentChannel.channelID
end sub

sub OnChannelSelected()
    print "OnChannelSelected..."
    if m.global.channels <> invalid and m.global.channels.Count() > 0
        m.top.TVchannel = m.curentChannel.channelNum
        GetUrl(true)
    end if
end sub
'*********************************************************** 
sub CreateProgramsList()
    if m.ProgramsListPanel = invalid
        print "...CREATE: Programs ListPanel" 
        m.ProgramsListPanel = createObject("RoSGNode","ProgramsListPanel")
        m.ProgramsListPanel.list.observeField("itemFocused", "OnProgramChange")
        m.ProgramsListPanel.list.observeField("itemSelected", "OnProgramSelected")
        m.top.panelSet.appendChild(m.ProgramsListPanel)
    end if
end sub

sub RemoveProgramsList()
    if m.ProgramsListPanel <> invalid
        print "...REMOVE: Programs ListPanel"
        m.ProgramsListPanel = invalid
    end if
end sub

sub OnProgramChange()
    print "OnProgramChange..."
    m.top.overhang.optionsText = getTr("Select date")
    if not m.top.panelSet.isGoingBack
        m.curentProgram = m.ProgramsListPanel.list.content.getChild(m.ProgramsListPanel.list.itemFocused)
        if m.curentProgram <> invalid
            print "OnProgramChange: ";m.curentProgram.programTitle
        end if
        if m.ProgramsListPanel.hasPrograms
            'm.ProgramsListPanel.leftLabel.text = getDayName(m.curentProgram.programDayOfWeek) + ", " + m.curentProgram.programDate
        end if
    else
        print "OnProgramChange: isGoingBack"
    end if
end sub

sub OnProgramSelected()
    print "OnProgramSelected..."
    if m.global.channels <> invalid and m.global.channels.Count() > 0
        if (not m.ProgramsListPanel.hasPrograms) or m.ProgramsListPanel.realTimeProgram = m.ProgramsListPanel.list.itemFocused
            if m.ProgramsListPanel.list.content.getChild(m.ProgramsListPanel.list.itemFocused).programNum >= 0
                print "OnProgramSelected: PLAY LIVE!"
                GetUrl(true)
            end if
        else 
            if m.curentChannel.channelRecord and m.curentProgram.programArchive
                print "OnProgramSelected: PLAY ARCHIVE!"
                GetUrl(false)
            else
                print "OnProgramSelected: PLAY FUTURE!"
            end if
        end if
    end if
end sub
'*********************************************************** 
sub CreateVideoPlayer()
    if(m.top.VideoPlayer=invalid)
        m.top.VideoPlayer = m.top.createChild("VideoPlayer")
        m.top.VideoPlayer.observeField("onTop", "OnVideoPlayerTop")
    end if
end sub

sub GetUrl(isLive)
    if m.top.VideoPlayer.isPlaying and isLive = true and m.top.VideoPlayer.isLive = true and m.top.VideoPlayer.playingChannel.channelID = m.curentChannel.channelID
        m.top.VideoPlayer.onTop = true
    else
        print "GET URL, m.curentGenre="+m.curentGenre.id.tostr() +", m.curentChannel="+m.curentChannel.channelID.tostr()
        m.top.VideoPlayer.isLive = isLive
        m.top.VideoPlayer.isCinema = CheckIsCinema(m.global.channels[m.curentChannel.channelNum].description)
        m.top.VideoPlayer.playingGenre = m.curentGenre
        m.top.VideoPlayer.playingChannel = m.curentChannel
        m.top.VideoPlayer.playingPrograms = m.ProgramsListPanel.list.content
        m.top.VideoPlayer.playingDayNum = m.ProgramsListPanel.dayNum
        
        if isLive
            date = CreateObject("roDateTime")
            timestamp = date.AsSeconds()
            shift = GetTimeShiftSeconds(m.curentChannel.channelNum)
            if(shift>0)
                timestamp = timestamp - shift
            end if
            m.top.VideoPlayer.videoStartTimestamp = timestamp
        else
            m.top.VideoPlayer.videoStartTimestamp = m.curentProgram.programTimestamp
        end if
    end if
end sub

sub OnVideoPlayerTop()
    if m.top.VideoPlayer.onTop = true
        if m.top.VideoPlayer.playingGenre.id <> m.curentGenre.id
            m.GenreListPanel.setFocus(true)
            m.GenreListPanel.list.jumpToItem = GetGenreNum(m.top.VideoPlayer.playingGenre.id)
        end if
        m.top.panelSet.opacity = 0
        m.top.VideoPlayer.setFocus(true)
        
        
    else
        m.ChannelsGridPanel.setFocus(true)
        if m.top.VideoPlayer.playingChannel<>invalid and m.top.VideoPlayer.playingChannel.channelID <> m.curentChannel.channelID
            m.ChannelsGridPanel.list.jumpToItem = m.top.VideoPlayer.playingChannel.channelNum
        end if
        m.top.panelSet.opacity = 1
        
        index = findProgramNodeByTimestamp( m.top.VideoPlayer.videoCurTimestamp, m.top.VideoPlayer.playingPrograms )
        if index >= 0
            m.ProgramsListPanel.list.jumpToItem = index
        end if
        'm.ProgramsListPanel.setFocus(true)
    end if
    
    InfoMessageVisible(not m.top.VideoPlayer.onTop)
end sub
'*********************************************************** 
'----------- MOVIES ----------------------------------------
'*********************************************************** 
sub CreateMoviesGenres()
    if(m.MoviesGenresPanel=invalid)
        print "...CREATE: Movies GenresPanel" 
        m.MoviesGenresPanel = createObject("RoSGNode", "MoviesGenres")
        m.MoviesGenresPanel.list.observeField("itemFocused", "OnMoviesGenreChange")
        m.MoviesGenresPanel.list.observeField("itemSelected", "OnMoviesGenreSelected")
        'm.top.panelSet.appendChild(m.MoviesGridPanel)
    end if
end sub

sub RemoveMoviesGenres()
    if m.MoviesGenresPanel <> invalid
        print "...REMOVE: Movies GenresPanel"
        m.MoviesGenresPanel = invalid
    end if
end sub

sub OnMoviesGenreChange()
    print "OnMoviesGenreChange..."
    if m.top.panelSet.isGoingBack
        print "OnMoviesGenreChange: isGoingBack"
        RemoveMovieInfo()
    else
        CreateMoviesGrid()
        m.MoviesGenresPanel.nextPanel = m.MoviesGridPanel

        m.curentGenre = m.global.moviesGenres[m.MoviesGenresPanel.list.itemFocused]
        m.MoviesGridPanel.parentPanel = "genres"
        m.MoviesGridPanel.genreName = m.curentGenre.title
        m.MoviesGridPanel.genreId = m.curentGenre.id
        m.MoviesGridPanel.leftLabel.text = ""
    end if
end sub

sub OnMoviesGenreSelected()
    print "OnMoviesGenreSelected..."
end sub
'***********************************************************
sub CreateMoviesGrid()
    if(m.MoviesGridPanel=invalid)
        print "...CREATE: Movies GridPanel" 
        m.MoviesGridPanel = createObject("RoSGNode","MoviesGridPanel")
        m.MoviesGridPanel.grid.observeField("itemFocused", "OnMovieChange")
        m.MoviesGridPanel.grid.observeField("itemSelected", "OnMovieSelected")
        'm.top.panelSet.appendChild(m.MoviesGridPanel)
    end if
end sub

sub RemoveMoviesGrid()
    if m.MoviesGridPanel <> invalid
        print "...REMOVE: Movies GridPanel"
        m.MoviesGridPanel.parentPanel = "null"
        m.MoviesGridPanel = invalid
    end if
end sub

sub OnMovieChange()
    if m.MoviesGridPanel = invalid
        print "OnMovieChange: Error! m.MoviesGridPanel = invalid"
    else
    
        print "OnMovieChange..."
        m.top.overhang.title = m.curentGenre.title
        m.top.overhang.optionsText = getTr("Sorting")
        if m.top.panelSet.isGoingBack
            print "OnMovieChange: isGoingBack Panels=";m.top.panelSet.numPanels
        else
            m.MoviesGridPanel.rightLabel.text = (m.MoviesGridPanel.grid.itemFocused+1).tostr()+" "+getTr("of")+" "+m.MoviesGridPanel.grid.content.getChildCount().tostr()
            CreateMovieInfo()
            m.MovieInfoPanel.movieNum = m.MoviesGridPanel.grid.itemFocused
        end if
    end if
end sub

sub OnMovieSelected()
    print "OnMovieSelected..."
    if m.global.movies <> invalid and m.global.movies.Count() > 0
        if m.global.movies.Count() > m.MoviesGridPanel.grid.itemFocused
            m.movie = m.global.movies[m.MoviesGridPanel.grid.itemFocused]
            if m.movie <> invalid
                movieId = m.movie.id
                if type(m.movie.id) = "String"
                    movieId = Int(movie.id)
                end if
                m.movie.id = movieId
                
                if m.movie.series
                    GetSeasons(m.movie)
                else
                    GetMovieUrl(m.movie, 0)
                end if
            else
                print "OnMovieSelected movie = invalid"
            end if 
        else
            print "OnMovieSelected bad index = ";index
        end if
    end if
end sub
'***********************************************************
sub GetSeasons(movie)
    print "...Get Seasons"
    m.global.loading = true
    m.request = createObject("roSGNode","GetRequest")
    m.request.uri = m.global.apipath+m.global.apiname+m.global.vodpath+"/vod/ws/Season?sessionId="+ m.global.sessionId+"&filmId="+movie.id.tostr()
    m.request.observeField("content","OnSeasons")
    m.request.control = "RUN"
end sub

sub OnSeasons()
    print "OnSeasons: "';m.request.content
    m.global.loading = false
    json = ParseJSON(m.request.content)
    if(json<>invalid and json.items<>invalid)
        print "OnSeasons: ";m.request.content
        seasonsNames = CreateObject("roArray", json.items.Count(), true)                  
        for x = 0 To json.items.Count()-1
            print "Season ";(x+1)
            seasonsNames[x] = getTr("Season")+" "+(x+1).tostr()
        end for

        ' TODO: add Translation
        m.dialog = createObject("roSGNode","Dialog")
        m.global.mainScene.dialog = m.dialog
        m.dialog.optionsDialog = true
        m.dialog.titleFont = m.global.fonts.regular20
        m.dialog.buttonGroup.textFont = m.global.fonts.regular18
        m.dialog.buttonGroup.focusedTextFont = m.global.fonts.regular18
        m.dialog.buttonGroup.focusBitmapUri = "pkg:/images/select.9.png"
        m.dialog.buttonGroup.focusFootprintBitmapUri = "pkg:/images/selected.9.png"

        m.dialog.title = getTr("Select season")
        m.dialog.buttons = seasonsNames
        m.dialog.focusButton = 0
        m.dialog.observeField("buttonSelected","OnSeasonsSelected")
    else
        print "...Seasons = Invalid! Error"
        ' TODO: Show Error - No Seasons
    end if
end sub

sub OnSeasonsSelected()
    if m.dialog <> invalid
        print "OnSeasonsSelected: ";(m.dialog.buttonSelected+1)
        GetSeries(m.movie, m.dialog.buttonSelected+1)
    end if  
end sub

sub GetSeries(movie, seasonNumber)
    print "...Get Seasons"
    m.global.loading = true
    m.request = createObject("roSGNode","GetRequest")
    m.request.uri = m.global.apipath+m.global.apiname+m.global.vodpath+"/vod/ws/Series?sessionId="+ m.global.sessionId+"&filmId="+movie.id.tostr()+"&season="+seasonNumber.tostr()
    m.request.observeField("content","OnSeries")
    m.request.control = "RUN"
end sub

sub OnSeries()
    print "OnSeries: "';m.request.content
    m.global.loading = false
    json = ParseJSON(m.request.content)
    if json<>invalid and json.items<>invalid
        m.series = json.items

        if m.global.hasField("series") 
            m.global.series = m.series
        else
            m.global.addFields({series: m.series})
        end if

        seriesNames = CreateObject("roArray", json.items.Count()+1, true)
        seriesNames[0] = "..."       
        for x = 1 To m.series.Count()
            if x > 9
                seriesNames[x]  = getTr("Episode")+" "+x.tostr()
            else
                seriesNames[x]  = getTr("Episode")+" 0"+x.tostr()
            end if
        end for

        UpdateSeriesList(m.global.series, 0)
    else
        print "...Seasons = Invalid! Error"
        ' TODO: Show Error - No Seasons
    end if
end sub

sub UpdateSeriesList(series, page)
    m.seriesPage = page
    m.seriesMax = 10

    if series.Count() > m.seriesMax 
        startIndex = m.seriesPage * m.seriesMax 
        seriesLeft = series.Count() - startIndex
        if seriesLeft > m.seriesMax
            seriesLeft = m.seriesMax
        end if

        seriesNames = CreateObject("roArray", seriesLeft+1, true)
        if page > 0
            seriesNames[0] = " /\ "
        else
            seriesNames[0] = "..."
        end if
        for x = 1 To seriesLeft
            if startIndex + x > 9
                seriesNames[x]  = getTr("Episode")+" "+(startIndex + x).tostr()
            else
                seriesNames[x]  = getTr("Episode")+" 0"+(startIndex + x).tostr()
            end if
        end for

        if series.Count() - startIndex > m.seriesMax
            seriesNames.Push(" \/ ")
        end if
    else
        seriesNames = CreateObject("roArray", series.Count()+1, true)
        seriesNames[0] = "..."
        for x = 1 To m.series.Count()
            if x > 9
                seriesNames[x]  = getTr("Episode")+" "+x.tostr()
            else
                seriesNames[x]  = getTr("Episode")+" 0"+x.tostr()
            end if
        end for
    end if

    ' TODO: Show series by pages
    ' TODO: add Translation
    m.dialog = createObject("roSGNode","Dialog")
    m.global.mainScene.dialog = m.dialog
    m.dialog.optionsDialog = true
    m.dialog.titleFont = m.global.fonts.regular20
    m.dialog.buttonGroup.textFont = m.global.fonts.regular18
    m.dialog.buttonGroup.focusedTextFont = m.global.fonts.regular18
    m.dialog.buttonGroup.focusBitmapUri = "pkg:/images/select.9.png"
    m.dialog.buttonGroup.focusFootprintBitmapUri = "pkg:/images/selected.9.png"

    m.dialog.title = getTr("Select Episode")
    m.dialog.buttons = seriesNames
    m.dialog.focusButton = 0
    m.dialog.observeField("buttonSelected","OnSeriesSelected")
end sub

sub OnSeriesSelected()
    if m.dialog <> invalid
        if m.dialog.buttonSelected = 0
            if m.seriesPage = 0
                GetSeasons(m.movie)
            else
                UpdateSeriesList(m.global.series, m.seriesPage-1)
            end if
        else if m.dialog.buttonSelected > m.seriesMax
            UpdateSeriesList(m.global.series, m.seriesPage+1)
        else
            seriesCurrent = m.series[m.dialog.buttonSelected-1]
            if m.global.hasField("seriesCurrent") 
                m.global.seriesCurrent = seriesCurrent
            else
                m.global.addFields({seriesCurrent: seriesCurrent})
            end if

            GetMovieUrl(m.movie, seriesCurrent.id)
        end if
    end if
end sub
'*********************************************************** 
sub CreateMovieInfo()
    if m.MovieInfoPanel = invalid
        print "...CREATE: MovieInfo Panel" 
        m.MovieInfoPanel = createObject("RoSGNode","MovieInfoPanel")
        m.top.panelSet.appendChild(m.MovieInfoPanel)
        m.top.MovieInfoPanel = m.MovieInfoPanel
    end if
end sub

sub RemoveMovieInfo()
    if m.MovieInfoPanel <> invalid
        print "...REMOVE: MovieInfo Panel"
        m.MovieInfoPanel = invalid
    end if
end sub
'*********************************************************** 
sub CreateMoviePlayer()
    if(m.top.MoviePlayer=invalid)
        m.top.MoviePlayer = m.top.createChild("MoviePlayer")
        m.top.MoviePlayer.observeField("onTop", "OnMoviePlayerTop")
    end if
end sub

sub OnMoviePlayerTop()
    if m.top.MoviePlayer.onTop = true
        m.top.panelSet.opacity = 0
        m.top.MoviePlayer.setFocus(true)
    else
        m.MoviesGridPanel.setFocus(true)
        m.top.panelSet.opacity = 1
    end if
    
    InfoMessageVisible(not m.top.MoviePlayer.onTop)
end sub

sub GetMovieUrl(movie, seriesID)
    CreateMoviePlayer()

    if movie <> invalid
        m.top.MoviePlayer.movieTitle = movie.title
        m.top.MoviePlayer.movieIconURI = movie.image.small
        m.top.MoviePlayer.movieSeriesID = seriesID
        m.top.MoviePlayer.movieID = movie.id
    end if
end sub
'*********************************************************** 
sub CreateMovieSearch()
    'if(m.MovieSearchPanel = invalid)
        print "...CREATE: MovieSearch Panel" 
        m.MovieSearchPanel = createObject("RoSGNode","MovieSearchPanel")
        m.MovieSearchPanel.observeField("searchString", "OnMovieSearch")
        m.MovieSearchPanel.observeField("hasFocus", "OnMovieSearchFocus")
        'm.top.panelSet.appendChild(m.MovieSearchPanel)
        m.top.MovieSearchPanel = m.MovieSearchPanel
    'end if
end sub

sub OnMovieSearchFocus()
    print "OnSearchFocus... hasFocus = ";m.MovieSearchPanel.hasFocus
    if not m.top.panelSet.isGoingBack
        if m.MovieSearchPanel.hasFocus = true
           RemoveMoviesGrid()
           m.MovieSearchPanel.hasFocus = false
           OnMovieSearch()
        end if
    end if
end sub 

sub OnMovieSearch()
    print "OnMovieSearch... searchString = ";m.MovieSearchPanel.searchString
    if Len(m.MovieSearchPanel.searchString) > 1
        CreateMoviesGrid()
        print "OnMovieSearch... parentPanel = ";m.MoviesGridPanel.parentPanel
        if m.MoviesGridPanel.parentPanel <> "search"
            m.MoviesGridPanel.parentPanel = "search"
            m.top.panelSet.appendChild(m.MoviesGridPanel)
        endif
        
        m.MoviesGridPanel.searchText = m.MovieSearchPanel.searchString
    end if
end sub

sub RemoveMovieSearch()
    if m.MovieSearchPanel <> invalid
        print "...REMOVE: MovieSearch Panel"
        m.MovieSearchPanel = invalid
    end if
end sub
'*********************************************************** 
'----------- Settings --------------------------------------
'*********************************************************** 
sub CreateSetting()
    if m.SettingsPanel = invalid
        print "...CREATE: Settings Panel" 
        m.SettingsPanel = createObject("RoSGNode","Settings")
        m.SettingsPanel.list.observeField("itemFocused", "OnSettingChange")
        m.SettingsPanel.list.observeField("itemSelected", "OnSettingSelected")
        'm.top.panelSet.appendChild(m.SettingsPanel)
    end if
end sub

sub RemoveSetting()
    if m.SettingsPanel <> invalid
        print "...REMOVE: Settings Panel"
        m.SettingsPanel = invalid
    end if
end sub

sub OnSettingChange()
    print "OnSettingChange..."
    if not m.top.panelSet.isGoingBack
        
    else
        print "OnSettingChange: isGoingBack"
    end if
end sub

sub OnSettingSelected()
    print "OnSettingSelected..."
end sub
'*********************************************************** 
sub checkInfoMessage()
    print "...checkInfoMessage"
    m.request = createObject("roSGNode","GetRequest")
    m.request.uri = m.global.apipath+m.global.apiname+"/core/ws/Information?languageId="+m.global.user.languageId.tostr()+"&sessionId="+m.global.sessionId
    m.request.observeField("content","OnInfoMessage")
    m.request.control = "RUN"
end sub

sub OnInfoMessage()
    print "OnInfoMessage: ";m.request.content
    json = ParseJSON(m.request.content)
    if(json<>invalid and json.items<>invalid)
        if (json.items.Count() > 0)
            print "Info Message: "+json.items[0].text
            m.top.InfoMessagePanel = createObject("roSGNode","InfoMessagePanel")
            m.top.InfoMessagePanel.message.text = json.items[0].text
            m.top.appendChild(m.top.InfoMessagePanel)
        else
            print "Info Message: Hiding..."
            
        end if
    else
        print "...InfoMessage = Invalid! Error"
    end if
end sub

sub InfoMessageVisible(visible)
    if m.top.InfoMessagePanel<>invalid
        m.top.InfoMessagePanel.visible = visible
    end if
end sub
'*********************************************************** 
sub setFonts()
    m.fonts = CreateObject("roAssociativeArray")
    
    m.fonts.regular16 = CreateObject("roSGNode", "Font")
    m.fonts.regular16.uri = "pkg:/components/Fonts/Open-Sans.ttf"
    m.fonts.regular16.size = 16
    
    m.fonts.regular18 = CreateObject("roSGNode", "Font")
    m.fonts.regular18.uri = "pkg:/components/Fonts/Open-Sans.ttf"
    m.fonts.regular18.size = 18
    
    m.fonts.regular20 = CreateObject("roSGNode", "Font")
    m.fonts.regular20.uri = "pkg:/components/Fonts/Open-Sans.ttf"
    m.fonts.regular20.size = 20
    
    m.fonts.regular24 = CreateObject("roSGNode", "Font")
    m.fonts.regular24.uri = "pkg:/components/Fonts/Open-Sans.ttf"
    m.fonts.regular24.size = 24
    
    m.fonts.bold20 = CreateObject("roSGNode", "Font")
    m.fonts.bold20.uri = "pkg:/components/Fonts/Open-Sans-Bold.ttf"
    m.fonts.bold20.size = 20
    
    m.fonts.bold32 = CreateObject("roSGNode", "Font")
    m.fonts.bold32.uri = "pkg:/components/Fonts/Open-Sans-Bold.ttf"
    m.fonts.bold32.size = 32
    
    m.global.addFields({
        fonts: m.fonts,
    })
end sub
'*********************************************************** 