sub init()
    print "INIT: GenreListPanel"
    
    m.top.panelSize = "medium"
    m.top.focusable = true
    m.top.hasNextPanel = true
    m.top.leftOnly = false
    m.top.goBackCount = 1
    m.top.createNextPanelOnItemFocus = true
    m.top.selectButtonMovesPanelForward = true
    m.top.languageChange = false
    
    m.GenreList = m.top.findNode("GenreList")
    m.top.list = m.GenreList 

    m.GenreList.font = m.global.fonts.regular24
    m.GenreList.focusedFont = m.global.fonts.regular24
    GetSubMenu()
end sub

sub GetSubMenu()
    if m.top.menuID = 0
        m.top.leftOnly = true
        m.top.hasNextPanel = true
    
        GetGenres()
    else if m.top.menuID = 1
        m.top.leftOnly = false
        m.top.hasNextPanel = false
        
        GetVideoCategories()
    else if m.top.menuID = 2
        m.top.leftOnly = true
        m.top.hasNextPanel = true
    
        GetSettings()
    end if
end sub
'******************************************************
sub GetGenres()
    print "...Get Genres"
    m.request = createObject("roSGNode","GetRequest")
    m.request.uri = m.global.apipath+m.global.apiname+"/core/ws/Genre?id=0&typeId=TV&deviceId=1&sessionId="+ m.global.sessionId
    m.request.observeField("content","OnGenres")
    m.request.control = "RUN"
end sub

sub OnGenres()
    print "OnGenres: ";m.request.content
    json = ParseJSON(m.request.content)
    if(json<>invalid)
        genres = CreateObject("roArray", json.total+2, true)
        genres[0]={line:true,typeId:"TV",name: getTr("All"),logo:"images/tv/genres/galaTV_03.png",allowed:true,id:-1,num:0}
        genres[1]={line:true,typeId:"TV",name: getTr("Favorites"),logo:"images/tv/genres/galaTV_02.png",allowed:true,id:0,num:1}

        'print "________Genres Names__________"
        'print genres[0].name
        'print genres[1].name
        for x = 0 To json.total-1
            genres[x+2] = json.items[x]
            genres[x+2].num = x+2
            'print genres[x+2].name
        End for
        'print "______________________________"
        m.global.addFields({genres: genres})
        UpdateGenres(genres)
    else
        print "...Genres = Invalid! Error" 
    end if
    
end sub

sub UpdateGenres(genres)
    GenreContent = createObject("RoSGNode","ContentNode")
    if genres<>invalid
        num = 0
        for each genre in genres
            node = GenreContent.createChild("ContentNode")
            node.title = genre.name
            'node.num = genre.num
            node.id = genre.id
            num++
        end for
    end if
    
    m.top.list.content = GenreContent
    'm.top.setFocus(true)
end sub
'******************************************************
sub GetVideoCategories()
    print "...Get VideoCategories"
    m.request = createObject("roSGNode","GetRequest")
    m.request.uri = m.global.apipath+m.global.apiname+m.global.vodpath+"/vod/ws/Configuration?sessionId="+ m.global.sessionId
    m.request.observeField("content","OnVideoCategories")
    m.request.control = "RUN"
end sub

sub OnVideoCategories()
    print "OnVideoCategories: "';m.request.content
    json = ParseJSON(m.request.content)
    if(json<>invalid and json.categories <> invalid and json.categories.Count() > 0)
        movieCategories = CreateObject("roArray", json.categories.Count()+1, true)
        movieCategories[0] = {title: getTr("Search"), logo: "Р", id: -1, description: getTr("Search"), genres:[]}
        'print "________Video Categories__________"
        for x = 0 To json.categories.Count()-1
            movieCategories[x+1] = json.categories[x]
        End for
        'print "______________________________"

        m.global.addFields({movieCategories: movieCategories})
        UpdateMovieCategories(movieCategories)

        'index = 1
        'jsonGenres = json.categories[index].genres
        'movieGenres = CreateObject("roArray", jsonGenres.Count()+1, true)
        ' TODO add translation
        'movieGenres[0]={line: true, typeId: "VD", title: getTr("Search"), logo: "Р", id: -1, allowed: true}
        'print "________Video Categories__________"
        'for x = 0 To jsonGenres.Count()-1
        '    movieGenres[x+1] = jsonGenres[x]
        '    print movieGenres[x].title
        'End for
        'print "______________________________"
        'm.global.addFields({movieGenres: movieGenres})
        'm.global.addFields({movieCategoryID: json.categories[index].id })
        'UpdateMovieCategories(movieGenres)
    else
        print "...Video Genres = Invalid! Error" 
    end if
end sub

sub UpdateMovieCategories(movieCategories)
    CategoryContent = createObject("RoSGNode","ContentNode")
    if movieCategories <> invalid
        for each category in movieCategories
            node = CategoryContent.createChild("ContentNode")
            node.title = category.title
            node.id = category.id
        end for
    end if
    m.top.list.content = CategoryContent
end sub
'******************************************************
sub GetSettings()
    m.top.languageChange = false

    content = createObject("RoSGNode","ContentNode")
    
    node = content.createChild("ContentNode")
    node.title = getTr("Profile")
    node.id = 0
    
    node = content.createChild("ContentNode")
    node.title = getTr("Language")
    node.id = 1
    
    'node = content.createChild("ContentNode")
    'node.title = "Time Zone"
    'node.id = 2
    
    node = content.createChild("ContentNode")
    node.title = getTr("TimeShift")
    node.id = 2
    
    node = content.createChild("ContentNode")
    node.title = getTr("Server")
    node.id = 3
    
    node = content.createChild("ContentNode")
    node.title = getTr("About")
    node.id = 4
    
    m.top.list.content = content
end sub
'******************************************************
Function OnKeyEvent(key, press) as Boolean    
    result = false
    if press then
        print "GenreList: OnkeyEvent = ";key
        if key = "options"
            '
        else if key = "OK" or key = "play"
        
        else if key = "left"
            if m.global.mainScene.VideoPlayer.isPlaying
                return true
            end if
        else if key = "right"
            if m.global.loading
                print "GenreList: OnkeyEvent = Can't use button! still loading ..."
                return true
            end if
        else if key = "back"
            if m.global.mainScene.VideoPlayer.isPlaying
                m.global.mainScene.VideoPlayer.onTop = true
                return true
            end if
        end if
    end if
    return result
End Function