sub init()
    print "INIT: ProgramsListPanel"
    
    m.top.panelSize = "medium"
    m.top.focusable = true
    m.top.hasNextPanel = false
    m.top.leftOnly = false
    m.top.createNextPanelOnItemFocus = false
    m.top.goBackCount = 1
    
    m.top.list = m.top.findNode("ProgramsMarkupList")
    m.top.list.itemClippingRect = [ 0.0, 0.0, 1000, 2000 ]
    m.top.list.numRows = 8
    m.top.list.vertFocusAnimationStyle = "floatingFocus"
    
    m.top.leftLabel.font = m.global.fonts.regular18
    m.top.leftLabel.color = m.global.color.highlight
    m.top.rightLabel.font = m.global.fonts.regular18
    m.top.rightLabel.color = m.global.color.text2
end sub
'******************************************************
sub GetPrograms()
    print "GetPrograms:  dayNum = "+ m.top.dayNum.tostr()
    GetProgramsByDay(m.top.dayNum)
end sub

sub GetProgramsByDay(day)
    print "...Get Programs"
    m.top.leftLabel.text = ""
    m.top.hasPrograms = false
    m.top.dayNum = day
    SetLoadingContent()

    m.request = createObject("roSGNode","GetRequest")
    m.request.uri = m.global.apipath+m.global.apiname+"/tv/ws/EpgPrograms?channelId="+m.top.channelId.tostr()+"&day="+m.top.dayNum.tostr()+"&sessionId="+m.global.sessionId
    'startDate = (m.global.lastTime - 7 * 86400)
    'endDate = (m.global.lastTime + 7 * 86400)
    'm.request.uri = m.global.apipath+m.global.apiname+"/tv/ws/EpgPrograms?channelId="+m.top.channelId.tostr()+"&startDate="+startDate.tostr()+"&endDate="+endDate.tostr()+"&sessionId="+m.global.sessionId
    m.request.observeField("content","OnPrograms")
    m.request.control = "RUN"
end sub

sub OnPrograms()
    print "OnPrograms: ";m.request.content
    json = ParseJSON(m.request.content)
    if(json<>invalid and json.total<>invalid)
        Programs = CreateObject("roArray", json.total, true)                  
        'print "________ Programs Names __________"
        for x = 0 To json.total-1
            programs[x]  = json.items[x]
            'print programs[x].title
        End for
        'print "______________________________"
        
        if(m.global.hasField("programs"))
            m.global.programs = programs
        else
            m.global.addFields({programs: programs})
        end if
        
        UpdatePrograms(programs)
    else
        print "...Programs = Invalid! Error"
        SetEmptyContent()
    end if    
end sub
'******************************************************
sub UpdatePrograms(programs)
    ProgramsContent = createObject("RoSGNode","ContentNode")
    m.top.realTimeProgram = findRealTimeProgram(programs) 
    
    if programs<>invalid
        for i = 0 to programs.Count()-1
            node = ProgramsContent.createChild("ProgramsListItemData")
            node.programNum = i
            node.programTime = programs[i].time
            node.programTitle = programs[i].title
            node.programArchive = programs[i].archive
            node.programDate = programs[i].date
            node.programDayOfWeek = programs[i].dayOfWeek
            node.programTimestamp = programs[i].timestamp
            node.programEndTimestamp = programs[i].endTimestamp

            if(i = m.top.realTimeProgram)
                node.programStatusUri = "pkg:/images/archive_live.png"
                
            else
                if(programs[i].archive)
                    if (m.global.channels[m.top.channelNum].record) 
                        node.programStatusUri = "pkg:/images/archive_yes.png"
                    else
                        node.programStatusUri = "pkg:/images/archive_no.png"
                    end if
                end if
            end if
          
        end for
    end if
    if programs.Count() > 0
        m.global.archiveDateString = getDayName(programs[0].dayOfWeek.toInt()) + ", " + programs[0].date
    else
        m.global.archiveDateString = GetDateString(m.top.dayNum, GetDateByDayNum(m.top.dayNum))
    end if
    
    m.top.leftLabel.text = m.global.archiveDateString
    
    if programs<>invalid and programs.Count()>0
        m.top.hasPrograms = true
        m.top.list.content = ProgramsContent
        
        AddChangeDate()
    else
        SetEmptyContent()
    endif
    
    if programs.Count()>4
        m.top.list.focusRow = 4
    else
        m.top.list.focusRow = 0
    end if
    
    if(m.top.realTimeProgram >= 0)
        m.top.list.jumpToItem = m.top.realTimeProgram 
    else 
        if m.top.realTimeProgram = -2
            m.top.list.jumpToItem = 0
        else
            m.top.list.jumpToItem = programs.Count()-1
        end if
        'index = findProgramNodeByTimestamp( m.global.mainScene.VideoPlayer.videoCurTimestamp, m.global.mainScene.VideoPlayer.playingPrograms )
        'if index >= 0
        '    m.top.list.jumpToItem = index
        'else 
        '    if programs.Count()>4
        '        m.top.list.jumpToItem = 4
        '    end if    
        'end if
    end if
    
    if m.global.mainScene.VideoPlayer<>invalid and m.global.mainScene.VideoPlayer.playingChannel<> invalid and m.global.mainScene.VideoPlayer.playingChannel.channelID.tostr() = m.top.channelId.tostr()
        m.global.mainScene.VideoPlayer.playingPrograms = m.top.list.content
    end if
end sub
'******************************************************
sub SetLoadingContent()
    ProgramsContent = createObject("RoSGNode","ContentNode")
    node = ProgramsContent.createChild("ProgramsListItemData")
    node.programTime = ""
    node.programTitle = getTr("Loading...")
    node.programStatusUri = ""
    m.top.list.focusRow = 0
    m.top.list.content = ProgramsContent
end sub

sub SetEmptyContent()
    ProgramsContent = createObject("RoSGNode","ContentNode")
    node = ProgramsContent.createChild("ProgramsListItemData")
    node.programTime = ""
    node.programTitle = getTr("Watch LIVE")
    node.programStatusUri = "pkg:/images/archive_live.png"
    
    if m.global.channels <> invalid and m.top.channelNum < m.global.channels.Count() and m.global.channels[m.top.channelNum] <> invalid
        title = GetCinemaTitle(m.global.channels[m.top.channelNum].description)
        if title <> invalid and title.Len() > 0
            print "CINEMA TITLE = " + title
            node.programTitle = title
        end if
        
        m.top.list.content = ProgramsContent
        if m.global.channels[m.top.channelNum].record
            AddChangeDate()  
        end if 
    else
        m.top.list.content = ProgramsContent 
    end if
end sub
'******************************************************
sub AddChangeDate()
    node = m.top.list.content.createChild("ProgramsListItemData")
    node.programNum = -1
    node.programTime = ""
    node.programTitle = getTr("Select date")
    node.programArchive = false
    node.programDate = 0
    node.programDayOfWeek = 0
    node.programTimestamp = 0
    node.programEndTimestamp = 0
    node.programStatusUri = "pkg:/images/icon_calendar.png"
end sub

sub ChangeDate()
    'if m.top.hasPrograms
        m.dialog = createObject("roSGNode","Dialog")
        m.dialog.title = getTr("Select date")
        m.dialog.optionsDialog = true
        m.dialog.titleFont = m.global.fonts.regular20
        m.dialog.buttonGroup.textFont = m.global.fonts.regular18
        m.dialog.buttonGroup.focusedTextFont = m.global.fonts.regular18
        m.dialog.buttonGroup.focusBitmapUri = "pkg:/images/select.9.png"
        m.dialog.buttonGroup.focusFootprintBitmapUri = "pkg:/images/selected.9.png"
        
        newarray = CreateObject("roArray", 15, true)
        for i= -7 to 6
            newarray.Push( GetDateString(i, GetDateByDayNum(i)))
        end for
        m.dialog.buttons = newarray
        m.dialog.focusButton = m.top.dayNum+7
        m.dialog.observeField("buttonSelected","OnDate")
        
        m.global.mainScene.dialog = m.dialog
    'end if
end sub

sub OnDate()
    if m.dialog <> invalid
        GetProgramsByDay(m.dialog.buttonSelected-7)
        m.dialog.close = true
    end if    
end sub

function GetDateByDayNum(dayNum) As Object
    date = CreateObject("roDateTime")
    timestamp = m.global.lastTime + (dayNum * 86400)
    shift = GetTimeShiftSeconds(m.top.channelNum)
    if(shift>0)
        timestamp = timestamp - shift
    end if
    date.FromSeconds(timestamp)
    return date
end function

function GetDateString(dayNum, date) As String
    'if dayNum = 0
    '    return( getDayName(-1) +", "+convertDateToDDMMYYYY(date))
    'end if
    return( getDayName(date.GetDayOfWeek()) +", "+convertDateToDDMMYYYY(date))
end function
'******************************************************
function findRealTimeProgram(programs) as Integer
    m.top.realTimeProgram = -1
    
    ' FIND TIMESHIFT OFFSET
    now = CreateObject("roDateTime")
    timestamp = now.AsSeconds()
    shift = GetTimeShiftSeconds(m.top.channelNum)
    if(shift>0)
        timestamp = timestamp - shift
    end if
    print "PLAY shift=" + Str(shift/3600)

    ' FIND REAL TIME PROGRAM by TIMESTAMP with TIMESHIFT
    m.top.realTimeProgram = findProgramByTimestamp(timestamp, programs)
    
    'm.top.realTimeProgram = findProgramByTimestamp(m.global.lastTime, programs)
    'if(m.top.realTimeProgram>-1)
    '    m.curProgram = m.top.realTimeProgram
    'end if
    
    '_playedProgram = findProgramByTimestamp(m.playPosition)
    'if(_playedProgram>-1)
    '    m.curProgram = _playedProgram
    'end if

    print "REALTIME PROGRAM: " + m.top.realTimeProgram.tostr() + "/" + m.global.programs.Count().tostr()
    return m.top.realTimeProgram
end function
'******************************************************
Function OnKeyEvent(key, press) as Boolean    
    result = false
    if press then
        print "ProgramsList: OnkeyEvent = ";key
        if key = "options"
            ChangeDate()
        else if key = "OK" or key = "play"
            if m.top.list.content.getChild(m.top.list.itemFocused).programNum = -1
                print "OnProgramSelected: NEXT DAY!"
                ChangeDate()
                return true
            end if 
        else if key = "back"
            if m.global.mainScene.VideoPlayer.isPlaying
                m.global.mainScene.VideoPlayer.onTop = true
                return true
            end if
        else if key = "fastforward"
            if m.top.dayNum < 7
                m.top.dayNum = m.top.dayNum + 1 
                GetProgramsByDay(m.top.dayNum)
                return true
            end if
            
        else if key = "rewind"
            if m.top.dayNum > -7
                m.top.dayNum = m.top.dayNum - 1 
                GetProgramsByDay(m.top.dayNum)
                return true
            end if
        end if
    end if
    return result
End Function